#include <Preferences.h>

#include "Config.h"


namespace Config {


static bool		isLoaded = false;
static Preferences	preferences;


static void
checkReady()
{
	if (isLoaded) {
		return;
	}

	preferences.begin("kimodem", false);
	isLoaded = true;
}


size_t
LastSSID(char *ssid, size_t ssidlen)
{
	size_t	len;
	checkReady();
	len = preferences.getString("SSID", ssid, ssidlen);
	if (len > 0) {
		// preferences.getString includes the null byte in 
		// the result. c.f. DQTNA.
		len--;
	}

	return len;
}


void
SetLastSSID(const char *ssid)
{
	checkReady();
	preferences.putString("SSID", ssid);
}


bool
StartTryConnecting()
{
	checkReady();
	return preferences.getBool("STC", true);
}


void
SetStartTryConnecting(bool opt)
{
	checkReady();
	preferences.putBool("STC", opt);
}


bool
EnableMeter()
{
	checkReady();
	return preferences.getBool("WCM", true);
}


void
SetEnableMeter(bool opt)
{
	checkReady();
	preferences.putBool("WCM", opt);
}


void
FactoryDefaults()
{
	preferences.clear();
}



}
